#include "spacesaving.h"
#include <iostream>

SpaceSaving::SpaceSaving(int size) {
    maxSize = size;
}

void SpaceSaving::update(long id, long delta) {
    int minid = -1;
    int minval = INT_MAX;
    bool found = false;
    for (int i = 0; i < v.size(); i++) {
        if (v[i].first == id) {
            v[i].second += delta;
            found = true;
        }
        else {
            if (v[i].second < minval) {
                minval = v[i].second;
                minid = i;
            }
        }
    }
    if (!found) {
        if (v.size() < maxSize)
            v.push_back({id, delta});
        else {
            assert(minid != -1);
            v[minid].first = id;
            v[minid].second += delta;
        }
    }
}

vector<pair<long, long>> SpaceSaving::getHeavy() {
    sort(v.begin(), v.end());
    return v;
}

void SpaceSaving::printHeavy() {
    for (auto x : v) {
        cout << x.first << ": " << x.second <<endl;
    }
}

void testSS() {
    SpaceSaving ss = SpaceSaving(3);
    ss.update(0,10);
    ss.update(1,5);
    ss.update(2,1);
    ss.update(3,2);
    ss.update(0,5);
    ss.update(2,5);
    vector<pair<long, long>> hh = ss.getHeavy();
    for (auto h : hh) {
        cout << h.first << ": " << h.second <<endl;
    }
}